#include "Log.au3"
#include "Misc.au3"
#include "Services.au3"


Global $sServiceName = "SessionChange"
Global $sServiceDisplayName = "SessionChange"



If Not @Compiled Then Exit
If Not _Singleton(@ScriptName) Then
	If $cmdline[0] > 0 Then
		If $cmdline[1] = "stop" or StringRight($cmdline[1],1) = "s" Then
		Else
			MsgBox(0, "SessionChange", "Process is running.")
			WriteLog("Process is running.")
			Exit
		EndIf
	Else
		MsgBox(0, "SessionChange", "Process is running.")
		WriteLog("Process is running.")
		Exit
	EndIf
EndIf



If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case "install", "-i", "/i"
			InstallService()
		Case "remove", "-u", "/u", "uninstall"
			RemoveService()
		Case "run", "-r", "/r", "start"
			_SelfRun($sServiceName,"start")
		Case "stop", "-s", "/s"
			_SelfRun($sServiceName,"stop")
		Case Else
			WriteLog(" - - - Help - - - " & @crlf)
			WriteLog(" Service Example Params : " & @crlf)
			WriteLog("  -i : Installs service" & @crlf)
			WriteLog("  -u : Removes service" & @crlf)
			WriteLog("  -r : Runs the service" & @crlf)
			WriteLog("  -s : Stops the service" & @crlf)
			WriteLog(" - - - - - - - - " & @crlf)
			Exit
	EndSwitch

Else
	If Not _Service_Exists($sServiceName) Then
		If Msgbox(20,"Service Not Installed.","Would you like to install this service?" & @CRLF & $sServiceName) = 6 Then
			If InstallService() Then
				If Msgbox(4,$sServiceName,"Service Installed Successfully." & @CRLF & "Do you wish to start the process?") = 6 Then _SelfRun($sServiceName,"start")
				EndIf
			Else
				Exit
		EndIf
	EndIf
EndIf



_Service_Init($sServiceName)



Func _Svc_Main()
	WriteLog("Service started: SessionChange")
	
	While $gServiceStateRunning
		Sleep(10)
	WEnd
	
	_Service_Cleanup()
	WriteLog("Service stopped: SessionChange")
EndFunc



Func InstallService()
;~ 	Set Logfile path
	RegWrite("HKEY_LOCAL_MACHINE\Software\SessionChange", "LogfilePath", "REG_SZ", @ScriptDir)
	$LogfilePath = @TempDir
	
;~ 	Check for Adminstrativee rights
	If Not(IsAdmin()) Then
		MsgBox(0, "SessionChange", "Admin rights needed, will exit now")
		WriteLog("Admin rights needed, will exit now")
		Exit
	EndIf
	
	WriteLog("Installing Service, Please Wait" & @CRLF)
	_Service_Create($sServiceName,$sServiceDisplayName,$SERVICE_WIN32_OWN_PROCESS,$SERVICE_AUTO_START, $SERVICE_ERROR_SEVERE, '"' & @SystemDir & '\' & @ScriptName & '"')
	
	If @error Then
		WriteLog("Problem Installing Service, Error number is " & @error & @CRLF & " message  : " & _WinAPI_GetLastErrorMessage())
		Return 0
	Else
		WriteLog("Installation of Service Successful")
	EndIf
	
	FileCopy(@ScriptName, @SystemDir & '\' & @ScriptName, 1)

	Return 1
	Exit
EndFunc



Func RemoveService()
	_Service_Stop($sServiceName)
	_Service_Delete($sServiceName)
	if not @error then WriteLog("Service Removed Successfully" & @crlf)
	Exit
EndFunc



Func _SelfRun($servicename,$action)
    $sCmdFile = 'sc ' & $action & ' "' & $servicename & '"'
    Run($sCmdFile, @TempDir, @SW_HIDE)
	Exit
EndFunc
